#!/bin/bash -e
permitlist=/etc/rhui-permitlist-china/permitlist
iptablesFile=/etc/sysconfig/iptables
ipsetFile=/etc/sysconfig/ipset

function AddIptablesRule() {
    rule="$@"
    if ! egrep -q -- "$rule" $iptablesFile; then
        echo "Iptables rule [$rule] not found in $iptablesFile. Adding..."
        iptables -I INPUT 4 $rule
    fi
}

# Enable ipset and whitelist
# TODO We renamed whitelist to permitlist in most places, but
#      ipset still has a whitelist object. Leaving this alone for now
! chkconfig ipset on
if ! grep -q whitelist $ipsetFile; then
    echo "whitelist not found in $ipsetFile. Creating..."
    ipset create whitelist hash:net
fi
for line in $(cat $permitlist); do
    # Ignore errors about ranges that already exist
    ! ipset add whitelist $line 2> /dev/null
done
sudo service ipset save

# Enable iptables and create default rules
! chkconfig iptables on
! service iptables start
AddIptablesRule "-p tcp -m state --state NEW -m tcp --dport 80 -j ACCEPT"
AddIptablesRule "-p tcp -m state --state NEW -m tcp --dport 5674 -j ACCEPT"
AddIptablesRule "-p tcp -m set --match-set whitelist src -m tcp --dport 443 -j ACCEPT"
sudo service iptables save
